// C Source File
// Created 7/22/2002; 10:39:33 AM

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

void invert_scr(void)//Routine from Cave Blaster
{
  register long *ptr;
  for(ptr=(long*)0x4c00;(unsigned long)ptr<=0x57b8;*ptr++^=-1);
}

void delay(void) {
	short int loop = 500, randNum;
	
	// generate random numbers to slow down the program...
	while (loop-- > 0) {
		randNum = rand() % loop;
	}
}

// Main Function
void _main(void)
{
	static unsigned short int pad1[]={0x7FFE,0xFFFF,0xFFFF,0x7FFE};
	static unsigned char pad2[]={0x60,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0xF0,0x60};
	static unsigned char ball[]={0x78,0xFC,0xFC,0xFC,0xFC,0x78};
	int x,y;
	float bx,by;
	float ang;
	int key;
	int a;
	float bspeed=1;
	long int time=0;
	int fbx,fby;
	int obx=77,oby=47;
	randomize();
	x=72;y=42;
	bx=77;by=47;
	ang=random(360);
	//ang=45;
	ClrScr();
	if (!GrayOn()) return;
	FontSetSys(F_8x10);
	SetPlane(0);
	ClrScr();
	DrawStr(55,44,"Pong 4",A_NORMAL);
	SetPlane(1);
	ClrScr();
	DrawStr(57,46,"Pong 4",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(41,72,"Phil Software",A_NORMAL);
	ngetchx();
	GrayOff();
	ClrScr();
	Sprite16(72,0,4,pad1,LCD_MEM,SPRT_XOR);
	Sprite16(72,95,4,pad1,LCD_MEM,SPRT_XOR);
	Sprite8(0,42,16,pad2,LCD_MEM,SPRT_XOR);
	Sprite8(155,42,16,pad2,LCD_MEM,SPRT_XOR);
	Sprite8(77,47,6,ball,LCD_MEM,SPRT_XOR);
	//Sprite8((int)(bx),(int)(by),6,ball,LCD_MEM,SPRT_XOR);
	//bx+=sin((float)(PI*ang/180))*bspeed;
	//by+=cos((float)(PI*ang/180))*bspeed;
	INT_HANDLER interrupt1 = GetIntVec(AUTO_INT_1);
	SetIntVec(AUTO_INT_1,DUMMY_HANDLER);
	while (1==1){
		key=_rowread(0xFFFE);
		if (key&1&&y>0){
			Sprite8(0,y,16,pad2,LCD_MEM,SPRT_XOR);
			Sprite8(155,y,16,pad2,LCD_MEM,SPRT_XOR);
			y-=3;
			Sprite8(0,y,16,pad2,LCD_MEM,SPRT_XOR);
			Sprite8(155,y,16,pad2,LCD_MEM,SPRT_XOR);
		}
		if (key&2&&x>0){
			Sprite16(x,0,4,pad1,LCD_MEM,SPRT_XOR);
			Sprite16(x,95,4,pad1,LCD_MEM,SPRT_XOR);
			x-=3;
			Sprite16(x,0,4,pad1,LCD_MEM,SPRT_XOR);
			Sprite16(x,95,4,pad1,LCD_MEM,SPRT_XOR);
		}
		if (key&4&&y<83){
			Sprite8(0,y,16,pad2,LCD_MEM,SPRT_XOR);
			Sprite8(155,y,16,pad2,LCD_MEM,SPRT_XOR);
			y+=3;
			Sprite8(0,y,16,pad2,LCD_MEM,SPRT_XOR);
			Sprite8(155,y,16,pad2,LCD_MEM,SPRT_XOR);
		}
		if (key&8&&x<143){
			Sprite16(x,0,4,pad1,LCD_MEM,SPRT_XOR);
			Sprite16(x,95,4,pad1,LCD_MEM,SPRT_XOR);
			x+=3;
			Sprite16(x,0,4,pad1,LCD_MEM,SPRT_XOR);
			Sprite16(x,95,4,pad1,LCD_MEM,SPRT_XOR);
		}
		bx+=sin(PI*ang/180)*bspeed;
		by+=cos(PI*ang/180)*bspeed;
		fbx=floor(bx);
		fby=floor(by);
		Sprite8(obx,oby,6,ball,LCD_MEM,SPRT_XOR);
		Sprite8(fbx,fby,6,ball,LCD_MEM,SPRT_XOR);
		obx=fbx;oby=fby;
		time++;
		if (fbx<=4||fbx>=149){
			if (fby>=y-4&&fby<=y+20){
				ang=360-ang;
				if (ang>180){
					a=fby-(y-4);
					if (a<4){
						ang=200;bx-=1.2;
					}else	if (a>20){
						ang=340;bx-=1.2;
					}else{
						a-=12;
						ang+=a;
					}
				}else{
					a=fby-(y-4);
					if (a<4){
						ang=160;bx+=1.2;
					}else if (a>20){
						ang=20;bx+=1.2;
					}else{
						a=24-a;
						a-=12;
						ang+=a;
					}
				}
			}else{
				break;
			}
		}
		if (fby<=4||fby>=89){
			if (bx>=x-4&&bx<=x+20){
				ang=180-ang;
				if (ang<0){ang+=360;}
				if (ang<270&&ang>90){
					a=fbx-(x-4);
					if (a<4){
						ang=250;by-=1.2;
					}else	if (a>20){
						ang=110;by-=1.2;
					}else{
						a=24-a;
						a-=12;
						ang+=a;
						if (ang<0){ang+=360;}
						if (ang>360){ang-=360;}
					}
				}else{
					a=fbx-(x-4);
					if (a<4){
						ang=290;by+=1.2;
					}else if (a>20){
						ang=70;by+=1.2;
					}else{
						a-=12;
						ang+=a;
						if (ang<0){ang+=360;}
						if (ang>360){ang-=360;}
					}
				}
			}else{
				break;
			}
		}
		if (time%50==0) bspeed+=0.1;
		if (_rowread(~2)&64){
			break;
		}
		//delay();
	}
	SetIntVec(AUTO_INT_1,interrupt1);
	for (a=0;a<=3;a++){
		delay();
	}
	if (kbhit()) ngetchx();
	FontSetSys(F_8x10);
	printf_xy(32,45,"Score:  %ld",time);
	if (kbhit()) ngetchx();
	ngetchx();
	invert_scr();
	if (random(10)<4){
		for (a=-32760;a<=32760;a++){
			DrawPix(random(160),random(100),A_REVERSE);
			DrawPix(random(160),random(100),A_REVERSE);
		}
	}else{
		for (a=0;a<=1000;a++){
			DrawLine(random(160),random(100),random(160),random(100),A_REVERSE);
			DrawLine(random(160),random(100),random(160),random(100),A_REVERSE);
		}
	}
	if (kbhit()) ngetchx();
}
